org.springframework.orm.hibernate4

## Class HibernateExceptionTranslator

- java.lang.Object
- - org.springframework.orm.hibernate4.HibernateExceptionTranslator

- All Implemented Interfaces:
    PersistenceExceptionTranslator
  Direct Known Subclasses:
    LocalSessionFactoryBean

      public class HibernateExceptionTranslator
      extends Object
      implements PersistenceExceptionTranslator

  `PersistenceExceptionTranslator` capable of translating `HibernateException` instances to Spring's `DataAccessException` hierarchy.

  Extended by `LocalSessionFactoryBean`, so there is no need to declare this translator in addition to a `LocalSessionFactoryBean`.

  When configuring the container with `@Configuration` classes, a `@Bean` of this type must be registered manually.

  Since:
    3.1
  Author:
    Juergen Hoeller
  See Also:
    `PersistenceExceptionTranslationPostProcessor`, `SessionFactoryUtils.convertHibernateAccessException(HibernateException)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HibernateExceptionTranslator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected DataAccessException` | `convertHibernateAccessException(HibernateException ex)` Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.
    `DataAccessException` | `translateExceptionIfPossible(RuntimeException ex)` Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic DataAccessException hierarchy, if possible.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HibernateExceptionTranslator

          public HibernateExceptionTranslator()

  - ### Method Detail

    - #### translateExceptionIfPossible

          public DataAccessException translateExceptionIfPossible(RuntimeException ex)

      Description copied from interface: `PersistenceExceptionTranslator`
      Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic DataAccessException hierarchy, if possible.

      Do not translate exceptions that are not understand by this translator: for example, if coming from another persistence framework, or resulting from user code and unrelated to persistence.

      Of particular importance is the correct translation to DataIntegrityViolationException, for example on constraint violation. Implementations may use Spring JDBC's sophisticated exception translation to provide further information in the event of SQLException as a root cause.

      Specified by:
        `translateExceptionIfPossible` in interface `PersistenceExceptionTranslator`
      Parameters:
        `ex` - a RuntimeException thrown
      Returns:
        the corresponding DataAccessException (or `null` if the exception could not be translated, as in this case it may result from user code rather than an actual persistence problem)
      See Also:
        `DataIntegrityViolationException`, `SQLExceptionTranslator`

    - #### convertHibernateAccessException

          protected DataAccessException convertHibernateAccessException(HibernateException ex)

      Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.
      Parameters:
        `ex` - HibernateException that occured
      Returns:
        a corresponding DataAccessException
      See Also:
        `SessionFactoryUtils.convertHibernateAccessException(org.hibernate.HibernateException)`